//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  N o t e b o o k   H a r d w a r e   C o n t r o l   A C P I   D L L
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  Suits ASUS Z99H (A8JS mainboard)
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  Written by: nullpointer@mail.ru, last updated: 23:10 12.03.2007, ABSOLUTELY NO WARRANTIES! USE AT OWN RISK!
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//  WARNING! Core2Duo patch for NHC 2.0 pre-release 04 required!
//  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

public static class ASUSTeK
{
    #region Notebook Asus A8JS : class A8JS
    public static class A8JS
    {
        #region Class for Asus A8JS FAN control : class FAN
        public static class FAN
        {
            public const string description = "ACPI fan manual software control";
            public const bool default_enable = false;
            public const int icon = 2;

            #region Value class for FAN_ON_OFF : class FAN_ON_OFF
            public static class FAN_ON_OFF
            {
                public const string description = "Current fan state (on\\off)";
                public const bool nhc_visible = true;
                public static int fan_on_off = 0;
                public const string unit = "off|on";

                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 1;
                    public const int nhc_default_value = 1;

                    public static bool nhc_on_write()
                    {
                        if (initialisation)
                        {
                            int a1 = 0, a2 = 0;
                            ACPI.NAME.Read("_TZ.PLCY", ref a1);
                            ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref a2);
                            FAN_SPEED.fan_speed = a2;
                            if ((a1 == 1) || (a2 < 0x30))
                            {
                                FAN_ON_OFF.fan_on_off = 0;
                            }
                            else
                            {
                                FAN_ON_OFF.fan_on_off = 1;
                            }
                            return true;
                        }
                        ACPI.NAME.Write("_TZ.PLCY", 0);
                        int[] inArg = { 0, 0 };
                        inArg[0] = FAN_WARNING.fan_warning; // Higher temperature limit
                        inArg[1] = 0;  // Lower temperature limit
                        int[] outArg = { 0 };
                        ACPI.METHOD.Call("_TZ.WTML", inArg, 2, ref outArg, 0);
                        int a, b, c, res;
                        a = 0x84;
                        if (fan_on_off != 0) b = FAN_SPEED.fan_speed;
                        else b = 0x13;
                        c = 0xC4;
                        res = ((a << 16) + (b << 8) + (c));
                        ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
                        ACPI.METHOD.Call("_TZ.UMIT");
                        if (FAN_ON_OFF.fan_on_off != 0)
                        {
                            int aa = 0;
                            ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref aa);
                            FAN_SPEED.fan_speed = aa;
                        }
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for FAN_SPEED : class FAN_SPEED
            public static class FAN_SPEED
            {
                public const string description = "Current fan speed (0 to 255)";
                public const bool nhc_visible = true;
                public static int fan_speed = 0;
                public const string unit = "";

                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 144;

                    public static bool nhc_on_write()
                    {
                        if (initialisation)
                        {
                            int a1 = 0;
                            ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref a1);
                            FAN_SPEED.fan_speed = a1;
                            return true;
                        }
                        if (FAN_ON_OFF.fan_on_off == 1)
                        {
                            int[] inArg = { 0, 0 };
                            inArg[0] = FAN_WARNING.fan_warning; // Higher temperature limit
                            inArg[1] = 0;  // Lower temperature limit
                            int[] outArg = { 0 };
                            ACPI.METHOD.Call("_TZ.WTML", inArg, 2, ref outArg, 0);
                            int a, b, c, res;
                            a = 0x84;
                            b = fan_speed;
                            c = 0xC4;
                            res = ((a << 16) + (b << 8) + (c));
                            ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
                            ACPI.METHOD.Call("_TZ.UMIT");
                        }
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for FAN_WARNING : class FAN_WARNING
            public static class FAN_WARNING
            {
                public const string description = "Hardware fan control enabled if CPU temperature is over";
                public const bool nhc_visible = true;
                public static int fan_warning = 55;
                public const string unit = "C";

                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 45;
                    public const int nhc_maximum_value = 55;
                    public const int nhc_default_value = 70;

                    public static bool nhc_on_write()
                    {
                        if (initialisation)
                        {
                            return true;
                        }
                        if (FAN_ON_OFF.fan_on_off == 1)
                        {
                            int[] inArg = { 0, 0 };
                            inArg[0] = FAN_WARNING.fan_warning; // Higher temperature limit
                            inArg[1] = 0;  // Lower temperature limit
                            int[] outArg = { 0 };
                            ACPI.METHOD.Call("_TZ.WTML", inArg, 2, ref outArg, 0);
                            int a, b, c, res;
                            a = 0x84;
                            b = FAN_SPEED.fan_speed;
                            c = 0xC4;
                            res = ((a << 16) + (b << 8) + (c));
                            ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
                            ACPI.METHOD.Call("_TZ.UMIT");
                        }
                        return true;
                    }
                }
            }
            #endregion
        }
        #endregion

        #region Class for Asus A8JS SFAN control : class SFAN
        public static class SFAN
        {
            public const string description = "ACPI fan automatic software control";
            public const bool default_enable = false;
            public const int icon = 2;

            #region Value class for SFAN_CPUTemperature : class SFAN_CPUTemperature
            public static class SFAN_CPUTemperature
            {
                public const string description = "Current CPU temperature";
                public const bool nhc_visible = true;
                public static int sfan_cputemperature = 0;
                public const string unit = "C";
            }
            #endregion

            #region Value class for SFAN_FanSpeed : class SFAN_FanSpeed
            public static class SFAN_FanSpeed
            {
                public const string description = "Current fan speed approximately";
                public const bool nhc_visible = true;
                public static int sfan_fanspeed = 0;
                public const string unit = " rpm";
            }
            #endregion

            #region Value class for SFAN_Profile : class SFAN_Profile
            public static class SFAN_Profile
            {
                public const string description = "Current profile";
                public const bool nhc_visible = true;
                public static int sfan_profile = 0;
                public const string unit = "";

                public static bool init_done = false;

                public static int[] t_ = { 0, 0, 0, 0, 0, 0 };
                public static int[] s_ = { 0, 0, 0, 0, 0, 0 };
                public static int[] d_ = { 0, 0, 0, 0, 0, 0 };
                public static int[] i_ = { 1, 2, 3, 4, 5, 6 };

                public static int sfan_profile_i = -1;
            }
            #endregion

            #region Value class for SFAN_WARNING : class SFAN_WARNING
            public static class SFAN_WARNING
            {
                public const string description = "Hardware fan control enabled if CPU temperature is over";
                public const bool nhc_visible = true;
                public static int sfan_warning = 0;
                public const string unit = "C";
            }
            #endregion

            #region Value class for SFAN_UpdateSpeed : class SFAN_UpdateSpeed
            public static class SFAN_UpdateSpeed
            {
                public const string description = "Update once in";
                public const bool nhc_visible = true;
                public static int sfan_updatespeed = 0;
                public const string unit = " second(s)";

                public static int sfan_refreshdivider = 0;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 1;
                    public const int nhc_maximum_value = 20;
                    public const int nhc_default_value = 5;

                    public static bool nhc_on_write()
                    {
                        // nothing to do; value used only by timer
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV1 : class SFAN_DIV1
            public static class SFAN_DIV1
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div1 = 1;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile1_S : class SFAN_SpeedProfile1_S
            public static class SFAN_SpeedProfile1_S
            {
                public const string description = "Profile 1, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile1_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 0;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(1, SFAN_SpeedProfile1.sfan_speedprofile1, SFAN_SpeedProfile1_S.sfan_speedprofile1_s, SFAN_SpeedProfile1_D.sfan_speedprofile1_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile1 : class SFAN_SpeedProfile1
            public static class SFAN_SpeedProfile1
            {
                public const string description = "Profile 1, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile1 = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 50;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(1, SFAN_SpeedProfile1.sfan_speedprofile1, SFAN_SpeedProfile1_S.sfan_speedprofile1_s, SFAN_SpeedProfile1_D.sfan_speedprofile1_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile1_D : class SFAN_SpeedProfile1_D
            public static class SFAN_SpeedProfile1_D
            {
                public const string description = "Profile 1, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile1_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 0;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(1, SFAN_SpeedProfile1.sfan_speedprofile1, SFAN_SpeedProfile1_S.sfan_speedprofile1_s, SFAN_SpeedProfile1_D.sfan_speedprofile1_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV2 : class SFAN_DIV2
            public static class SFAN_DIV2
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div2 = 2;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile2_S : class SFAN_SpeedProfile2_S
            public static class SFAN_SpeedProfile2_S
            {
                public const string description = "Profile 2, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile2_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 144;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(2, SFAN_SpeedProfile2.sfan_speedprofile2, SFAN_SpeedProfile2_S.sfan_speedprofile2_s, SFAN_SpeedProfile2_D.sfan_speedprofile2_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile2 : class SFAN_SpeedProfile2
            public static class SFAN_SpeedProfile2
            {
                public const string description = "Profile 2, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile2 = 0;
                public const string unit = "C";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 60;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(2, SFAN_SpeedProfile2.sfan_speedprofile2, SFAN_SpeedProfile2_S.sfan_speedprofile2_s, SFAN_SpeedProfile2_D.sfan_speedprofile2_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile2_D : class SFAN_SpeedProfile2_D
            public static class SFAN_SpeedProfile2_D
            {
                public const string description = "Profile 2, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile2_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 30;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(2, SFAN_SpeedProfile2.sfan_speedprofile2, SFAN_SpeedProfile2_S.sfan_speedprofile2_s, SFAN_SpeedProfile2_D.sfan_speedprofile2_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV3 : class SFAN_DIV3
            public static class SFAN_DIV3
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div3 = 3;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile3_S : class SFAN_SpeedProfile3_S
            public static class SFAN_SpeedProfile3_S
            {
                public const string description = "Profile 3, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile3_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 165;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(3, SFAN_SpeedProfile3.sfan_speedprofile3, SFAN_SpeedProfile3_S.sfan_speedprofile3_s, SFAN_SpeedProfile3_D.sfan_speedprofile3_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile3 : class SFAN_SpeedProfile3
            public static class SFAN_SpeedProfile3
            {
                public const string description = "Profile 3, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile3 = 0;
                public const string unit = "C";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 70;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(3, SFAN_SpeedProfile3.sfan_speedprofile3, SFAN_SpeedProfile3_S.sfan_speedprofile3_s, SFAN_SpeedProfile3_D.sfan_speedprofile3_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile3_D : class SFAN_SpeedProfile3_D
            public static class SFAN_SpeedProfile3_D
            {
                public const string description = "Profile 3, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile3_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 57;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(3, SFAN_SpeedProfile3.sfan_speedprofile3, SFAN_SpeedProfile3_S.sfan_speedprofile3_s, SFAN_SpeedProfile3_D.sfan_speedprofile3_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV4 : class SFAN_DIV4
            public static class SFAN_DIV4
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div4 = 4;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile4_S : class SFAN_SpeedProfile4_S
            public static class SFAN_SpeedProfile4_S
            {
                public const string description = "Profile 4, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile4_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 188;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(4, SFAN_SpeedProfile4.sfan_speedprofile4, SFAN_SpeedProfile4_S.sfan_speedprofile4_s, SFAN_SpeedProfile4_D.sfan_speedprofile4_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile4 : class SFAN_SpeedProfile4
            public static class SFAN_SpeedProfile4
            {
                public const string description = "Profile 4, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile4 = 0;
                public const string unit = "C";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 80;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(4, SFAN_SpeedProfile4.sfan_speedprofile4, SFAN_SpeedProfile4_S.sfan_speedprofile4_s, SFAN_SpeedProfile4_D.sfan_speedprofile4_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile4_D : class SFAN_SpeedProfile4_D
            public static class SFAN_SpeedProfile4_D
            {
                public const string description = "Profile 4, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile4_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 67;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(4, SFAN_SpeedProfile4.sfan_speedprofile4, SFAN_SpeedProfile4_S.sfan_speedprofile4_s, SFAN_SpeedProfile4_D.sfan_speedprofile4_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV5 : class SFAN_DIV5
            public static class SFAN_DIV5
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div5 = 5;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile5_S : class SFAN_SpeedProfile5_S
            public static class SFAN_SpeedProfile5_S
            {
                public const string description = "Profile 5, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile5_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 213;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(5, SFAN_SpeedProfile5.sfan_speedprofile5, SFAN_SpeedProfile5_S.sfan_speedprofile5_s, SFAN_SpeedProfile5_D.sfan_speedprofile5_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile5 : class SFAN_SpeedProfile5
            public static class SFAN_SpeedProfile5
            {
                public const string description = "Profile 5, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile5 = 0;
                public const string unit = "C";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 90;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(5, SFAN_SpeedProfile5.sfan_speedprofile5, SFAN_SpeedProfile5_S.sfan_speedprofile5_s, SFAN_SpeedProfile5_D.sfan_speedprofile5_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile5_D : class SFAN_SpeedProfile5_D
            public static class SFAN_SpeedProfile5_D
            {
                public const string description = "Profile 5, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile5_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 77;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(5, SFAN_SpeedProfile5.sfan_speedprofile5, SFAN_SpeedProfile5_S.sfan_speedprofile5_s, SFAN_SpeedProfile5_D.sfan_speedprofile5_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_DIV6 : class SFAN_DIV6
            public static class SFAN_DIV6
            {
                public const string description = "Profile";
                public const bool nhc_visible = true;
                public static int sfan_div6 = 6;
                public const string unit = "";
            }
            #endregion

            #region Value class for SFAN_SpeedProfile6_S : class SFAN_SpeedProfile6_S
            public static class SFAN_SpeedProfile6_S
            {
                public const string description = "Profile 6, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile6_s = 0;
                public const string unit = "";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 255;
                    public const int nhc_default_value = 255;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(6, SFAN_SpeedProfile6.sfan_speedprofile6, SFAN_SpeedProfile6_S.sfan_speedprofile6_s, SFAN_SpeedProfile6_D.sfan_speedprofile6_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile6 : class SFAN_SpeedProfile6
            public static class SFAN_SpeedProfile6
            {
                public const string description = "Profile 6, the highest CPU temperature allowed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile6 = 0;
                public const string unit = "C";
                public static bool initialisation = false;

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 100;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(6, SFAN_SpeedProfile6.sfan_speedprofile6, SFAN_SpeedProfile6_S.sfan_speedprofile6_s, SFAN_SpeedProfile6_D.sfan_speedprofile6_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfile6_D : class SFAN_SpeedProfile6_D
            public static class SFAN_SpeedProfile6_D
            {
                public const string description = "Profile 6, deactivate profile if CPU temperature is below or equals to";
                public const bool nhc_visible = true;
                public static int sfan_speedprofile6_d = 0;
                public const string unit = "C";

                public static class NHC_WRITE
                {
                    public const bool nhc_write = true;
                    public const int nhc_minimum_value = 0;
                    public const int nhc_maximum_value = 100;
                    public const int nhc_default_value = 87;

                    public static bool nhc_on_write()
                    {
                        SFAN_UpdateProfile(6, SFAN_SpeedProfile6.sfan_speedprofile6, SFAN_SpeedProfile6_S.sfan_speedprofile6_s, SFAN_SpeedProfile6_D.sfan_speedprofile6_d);
                        return true;
                    }
                }
            }
            #endregion

            #region Value class for SFAN_SpeedProfileDefault : class SFAN_SpeedProfileDefault
            public static class SFAN_SpeedProfileDefault
            {
                public const string description = "Default profile, fan speed";
                public const bool nhc_visible = true;
                public static int sfan_speedprofiledefault = 255;
                public const string unit = "";
                public static bool initialisation = false;
            }
            #endregion

            public const int refresh_interval = 1;
            public static bool refresh()
            {
                if (!SFAN_Profile.init_done)
                {
                    SFAN_UpdateProfile(1, SFAN_SpeedProfile1.sfan_speedprofile1, SFAN_SpeedProfile1_S.sfan_speedprofile1_s, SFAN_SpeedProfile1_D.sfan_speedprofile1_d);
                    SFAN_UpdateProfile(2, SFAN_SpeedProfile2.sfan_speedprofile2, SFAN_SpeedProfile2_S.sfan_speedprofile2_s, SFAN_SpeedProfile2_D.sfan_speedprofile2_d);
                    SFAN_UpdateProfile(3, SFAN_SpeedProfile3.sfan_speedprofile3, SFAN_SpeedProfile3_S.sfan_speedprofile3_s, SFAN_SpeedProfile3_D.sfan_speedprofile3_d);
                    SFAN_UpdateProfile(4, SFAN_SpeedProfile4.sfan_speedprofile4, SFAN_SpeedProfile4_S.sfan_speedprofile4_s, SFAN_SpeedProfile4_D.sfan_speedprofile4_d);
                    SFAN_UpdateProfile(5, SFAN_SpeedProfile5.sfan_speedprofile5, SFAN_SpeedProfile5_S.sfan_speedprofile5_s, SFAN_SpeedProfile5_D.sfan_speedprofile5_d);
                    SFAN_UpdateProfile(6, SFAN_SpeedProfile6.sfan_speedprofile6, SFAN_SpeedProfile6_S.sfan_speedprofile6_s, SFAN_SpeedProfile6_D.sfan_speedprofile6_d);
                    SFAN_OnRefresh(true);
                    SFAN_Profile.init_done = true;
                }
                if (SFAN_UpdateSpeed.sfan_refreshdivider < SFAN_UpdateSpeed.sfan_updatespeed)
                {
                    SFAN_UpdateSpeed.sfan_refreshdivider++;
                    return true;
                }
                SFAN_UpdateSpeed.sfan_refreshdivider = 0;
                SFAN_OnRefresh(false);
                return true;
            }

            private static int SFAN_GetRPM(int speed)
            {
                double y = 0;
                double x = 0;
                x = (double)speed;
                if ((speed >= 0) && (speed <= 144)) y = 22.22 * x + 0;
                else if ((speed > 144) && (speed <= 165)) y = 23.81 * x + -228.57;
                else if ((speed > 165) && (speed <= 188)) y = 21.74 * x + 113.04;
                else if ((speed > 188) && (speed <= 213)) y = 16 * x + 1192;
                else if ((speed > 213) && (speed <= 255)) y = 11.9 * x + 2064.29;
                int yy = 0;
                yy = (int)y;
                if (y - yy > 0.5) yy++;
                return yy;
            }

            private static bool SFAN_OnRefresh(bool force_refresh)
            {
                int temperature_current = 0;
                int speed_current0 = 0;
                int speed_current1 = 0;
                int speed_current2 = 0;
                int profile_current = SFAN_Profile.sfan_profile;
                bool ok = false;
                ACPI.FIELD.Read("_TZ.THRM._TMP", ref temperature_current);
                temperature_current = (temperature_current - 2732) / 10;
                ACPI.FIELD.Read("_SB.PCI0.SBRG.EC0.CDT1", ref speed_current0);
                ACPI.NAME.Read("_TZ.FANL", ref speed_current1);
                ACPI.NAME.Read("_TZ.FANC", ref speed_current2);
                if (force_refresh)
                {
                    for (int i = 0; i < 6; i++)
                    {
                        if (temperature_current <= SFAN_Profile.t_[i])
                        {
                            SFAN_SetCPUFanSpeed(SFAN_Profile.s_[i], SFAN_Profile.t_[i]);
                            SFAN_Profile.sfan_profile = SFAN_Profile.i_[i];
                            SFAN_Profile.sfan_profile_i = i;
                            ok = true;
                            break;
                        }
                    }
                }
                else
                {
                    for (int i = 0; i < 6; i++)
                    {
                        if (temperature_current <= SFAN_Profile.t_[i])
                        {
                            if (SFAN_Profile.sfan_profile_i > i) // spin down
                            {
                                if (temperature_current <= SFAN_Profile.d_[SFAN_Profile.sfan_profile_i])
                                {
                                    SFAN_SetCPUFanSpeed(SFAN_Profile.s_[i], SFAN_Profile.t_[i]);
                                    SFAN_Profile.sfan_profile = SFAN_Profile.i_[i];
                                    SFAN_Profile.sfan_profile_i = i;
                                }
                            }
                            else if (SFAN_Profile.sfan_profile_i < i) // spin up
                            {
                                SFAN_SetCPUFanSpeed(SFAN_Profile.s_[i], SFAN_Profile.t_[i]);
                                SFAN_Profile.sfan_profile = SFAN_Profile.i_[i];
                                SFAN_Profile.sfan_profile_i = i;
                            }
                            else if (SFAN_Profile.sfan_profile_i == i) // same profile
                            {
                                if ((speed_current0 != speed_current1) || (speed_current1 != speed_current2) || (speed_current0 != speed_current2))
                                {
                                    SFAN_SetCPUFanSpeed(SFAN_Profile.s_[i], SFAN_Profile.t_[i]);
                                    SFAN_Profile.sfan_profile = SFAN_Profile.i_[i];
                                    SFAN_Profile.sfan_profile_i = i;
                                }
                            }
                            ok = true;
                            break;
                        }
                    }
                }
                if (!ok)
                {
                    SFAN_SetCPUFanSpeed(255, 100);
                }
                SFAN_CPUTemperature.sfan_cputemperature = temperature_current;
                return true;
            }

            private static bool SFAN_SetCPUFanSpeed(int speed, int maxtemperature)
            {
                ACPI.NAME.Write("_TZ.FANL", speed);
                ACPI.NAME.Write("_TZ.FANC", speed);
                ACPI.NAME.Write("_TZ.PLCY", 0);
                int[] inArg = { 0, 0 };
                inArg[0] = maxtemperature + 5; // Higher temperature limit
                inArg[1] = 0;  // Lower temperature limit
                int[] outArg = { 0 };
                ACPI.METHOD.Call("_TZ.WTML", inArg, 2, ref outArg, 0);
                int a, b, c, res;
                a = 0x84;
                b = speed;
                c = 0xC4;
                res = ((a << 16) + (b << 8) + (c));
                ACPI.METHOD.SetValue("_SB.ATKD.ECRW", res);
                ACPI.METHOD.Call("_TZ.UMIT");
                SFAN_WARNING.sfan_warning = maxtemperature + 5;
                SFAN_FanSpeed.sfan_fanspeed = SFAN_GetRPM(speed);
                return true;
            }

            private static bool SFAN_UpdateProfile(int profile, int maxtemperature, int speed, int mintemperature)
            {
                int idx = 0;
                for (int i = 0; i < 6; i++)
                {
                    if (SFAN_Profile.i_[i] == profile)
                    {
                        idx = i;
                        break;
                    }
                }
                SFAN_Profile.t_[idx] = maxtemperature;
                SFAN_Profile.s_[idx] = speed;
                SFAN_Profile.d_[idx] = mintemperature;
                int tmp;
                for (int i = 1; i < 6; i++)
                {
                    for (int j = 5; j > 0; j--)
                    {
                        if (SFAN_Profile.t_[j - 1] > SFAN_Profile.t_[j])
                        {
                            tmp = SFAN_Profile.t_[j];
                            SFAN_Profile.t_[j] = SFAN_Profile.t_[j - 1];
                            SFAN_Profile.t_[j - 1] = tmp;
                            tmp = SFAN_Profile.s_[j];
                            SFAN_Profile.s_[j] = SFAN_Profile.s_[j - 1];
                            SFAN_Profile.s_[j - 1] = tmp;
                            tmp = SFAN_Profile.i_[j];
                            SFAN_Profile.i_[j] = SFAN_Profile.i_[j - 1];
                            SFAN_Profile.i_[j - 1] = tmp;
                            tmp = SFAN_Profile.d_[j];
                            SFAN_Profile.d_[j] = SFAN_Profile.d_[j - 1];
                            SFAN_Profile.d_[j - 1] = tmp;
                        }
                    }
                }
                if (SFAN_Profile.init_done) SFAN_OnRefresh(true);
                return true;
            }
        }
        #endregion
    }
    #endregion
}
